﻿local nkRebuffInfo, nkRebuff = ...

if Inspect.System.Language() ~= "German" and  Inspect.System.Language() ~= "Russian" then
	
	nkRebuff.langTexts = {
	
		basicUI = {
			tabHeader1 = 'Setup',
			tabHeader2 = "About nkRebuff",
			btClose = "close",	
			btResetHidden = "show all",
			btResetData = 'delete data',
			btExportBarSetup = 'export bars',
			btImportBarSetup = 'import bars',
			btDonate			= 'donate'
		},
	 
		various = {
			version = "version",
			msgLoaded = "%s %s loaded",
			buttonMenuConfig = "Configuration",
			buttonMenuResetTempHides = "Show all",
			activateSet = 'Activating set %s',
			commandSetRefuse = 'Invalid set! valid values are 1 - %d',
			castBy = 'Cast by: %s'
		},
	 
		abilityBars = {
			barLabelBuffs = "Buffs player",
			barLabelDebuffs = "Debuffs target",
			barLabelDebuffsPlayer = "Debuffs player",
			barLabelActive = "Active abilities",
			barLabelCooldowns = 'Cooldowns',
			barLabelWarning = 'Warnings',
			barLabelBuffsPlayer = 'Buffs target',
			cbNoWarning = 'Do not warn',
			iconHelp = 'Left click the icon to hide this item until relog'
		},
		
		genericSettings = {
			basic = 'Basic settings',
			functions = 'Functions',
			performance = 'Performance',
			active = 'addon activated',
			slThrottle = 'update interval %.1f sec',
			slCounterCorr = 'adjust timer %.1f sec',
			locked = 'bars locked',
			roleSwitch = 'recognize role change',
			currentSet = 'current set',
			cbEvents = "buff/debuff recognition",
			cbDebuffWarning = "player debuff warning",
			cbNewDebuffActive = "activate new debuffs",
			sets = 'Ability sets',
			btAddSet = 'add set',
			newSetName = 'new set %d',
			copiedSetName = 'copy of %s',
			btRemoveSet = 'delete set',
			btCopySet = 'copy set',
			role = 'assigned role',
			cbCombat = "show only in combat",
			showBarsDuringConfig = 'show bars during config.',
			cbRemainingWarning = 'seperate bar for expiring',
			slGCD = 'global cooldown %.1f sec.',
			selectionRole = {{ label = 'Default', value = 0 }, { label = 'Role 1', value = 1}, { label = 'Role 2', value = 2}, { label = 'Role 3', value = 3}, { label = 'Role 4', value = 4}, { label = 'Role 5', value = 5}, { label = 'Role 6', value = 6}},
			cbDebugAddon = 'Debug mode',
		},
			
		barSettings = {	
			basic = 'Basic settings',
			slScale = "scale",
			slnoOfIcons = "# icons",
			slRunoutDuration = "show if less than %d secs",
			slAlpha = "transparancy",
			cbFadein = "fade in",
			rbAlign = "orientation",
			rbColorBorder = "border color",
			rbColorCounter = "counter color",
			rbColorStack = 'stacks color',
			rbColorLabel = "label color",
			slFontSize = "font size",
			design = 'Design',
			texts = 'Texts',
			border = 'border',
			label = 'label',
			tooltip = 'show tooltip',
			hideOnLeftClick = 'left click to hide',
			txtPosition = 'Positioning',
			slStackFontSize = 'stacks font size',
			slCounterFontSize = 'counter font size',
			posSel = {	{ label = 'centered', value = 'CENTER@CENTER@0@0' }, 
						{ label = 'inner left top', value = 'TOPLEFT@TOPLEFT@-2@4' }, { label = 'inner left bottom', value = 'BOTTOMLEFT@BOTTOMLEFT@-2@-4' } , { label = 'inner right top', value = 'TOPRIGHT@TOPRIGHT@2@4' }, { label = 'inner right bottom', value = 'BOTTOMRIGHT@BOTTOMRIGHT@2@-4' },
						{ label = 'outer left top', value = 'TOPRIGHT@TOPLEFT@2@4' }, { label = 'outer left bottom', value = 'BOTTOMRIGHT@BOTTOMLEFT@2@-4' } , { label = 'outer right top', value = 'TOPLEFT@TOPRIGHT@-2@4' }, { label = 'outer right bottom', value = 'BOTTOMLEFT@BOTTOMRIGHT@2@-4' } },
			borderSelection = {{label = 'no border', value = 0 }, {label = 'thin border', value = 1}, { label = 'middle border', value = 2}, { label = 'thick border', value = 3}},
			labelSelection = {{label = 'no texts', value = 0 }, {label = 'short texts', value = 1}, { label = 'show texts', value = 2}},
			colorSelection = {{label = "black", value = '000000' }, {label = "white", value = 'FFFFFF'}, { label = "red", value = '7F0000'}, { label = "yellow", value = 'FFD800'}, { label = "blue", value = '0094FF'}},
			alignSelection = {{label = 'fixed left to right', value = 'fixed' }, {label = 'left', value = 'left' }, {label = 'centered', value = 'centered'}, { label = 'right', value = 'right'}, { label = 'vertical', value = 'vertical'}}
		},
		
		trackSettings = {
			headerDescription= "description",
			headerStatus = "status",
			headerAdvanced = 'advanced',
			headerCastBy = 'cast by',
			headerSort = 'sort',
			txtActive = 'activated',
			selSetting = 'abilities',
			cbActiveOnly = "only activated",
			cbUseableOnly = 'only for current role',
			lblSearch = 'search',
			settingSelection = {	{ value = 1, label = "buffs - with duration"}, { value = 2, label = "buffs - permanent"}, { value = 3, label = "buffs - other" },
									{ value = 4, label = "buffs - of other players"}, { value = 5, label = "debuffs - target"}, { value = 6, label = "cooldowns"}, 
									{ value = 7, label = "debuffs - of other players"}, { value = 8, label = "buffs - target"}, { value = 9, label = "buffs - pet"} }
		},
		
		debuffList = {
			headerDescription= "description",
			headerCastBy = 'cast by',
			headerCalling = 'Calling',
			headerLevel = 'Lvl',
			headerTagName = 'Info',
			btClear = 'Clear',
			btRefresh = 'Update',
		},
		
		settingsTab = {
			generic = "Generic",
			barBuff = "Buff bar player",
			barDebuffTarget = "Debuff bar target",
			barDebuffPlayer = "Debuff bar player",
			barCooldown = "Cooldown bar",
			barActive = 'Active CD bar',
			barWarning = 'Warning',
			barBuffTarget = "buff bar target",
			track = 'Track abilities',
			debuffList = 'Debuff list'
		},

		advSettingsDialog = {
			stacksLabel = 'show if stacks are',
			stacksCount = 'stack count',
			slRunoutDuration = "show if less than %d secs",
			cbCustomRemaining = 'custom runout duration',
			btSave = 'Save',
			slsortPrioLabel = 'priority %d',
			cbNoActivityTracking = 'do not show active ability',
			cbNoWarning = 'do not use warning bar',
			cbDoNotShowMissing = 'reverse mode: show if active',
			cbCombatOnly = 'show only in combat',
			selectStacksCondition = {{ label = 'deactivated', value = 0 }, { label = 'Less than', value = 1}, {label = 'Exactly', value = 2 }, { label = 'More than', value = 3 }}
		},
		
		messages = {
			dialogTitle = 'Error message',
			cannotRemoveLastSet = 'You cannot delete the last set!',
			removeCurrentSet = 'Are you sure you want to delete the set?',
			msgClearAllData = 'Do you really want to delete ALL data?',
			msgImportBarData = 'Do you really want to load the global bar setup?',
			msgNoGlobalSettings = 'No global bar setup has been set!',
		},
		
		classes = {
			warrior = 'Warrior',
			rogue = 'Rogue',
			cleric = 'Cleric',
			mage = 'Mage',
			player = 'Player',
			NPC = 'NPC',
			unknown = 'Unknown'
		},
		
		about = {
			addonName = '%s',
			version = 'version %s',
			writtenBy = 'Written by Naifu / Defiant / Bruttmutter (EU)',
			copyright = '(C) 2011-2012 Naifu - All Rights Reserved',
			donate1 = 'If you like this addon you can send a paypal donation',
			donate2 = 'at the account naifukishi@gmail.com',
			patchCD = 'Cooldown patch by Beckmann',
			patchDebuff = 'Debuff filter patch by Eleyo',
			russian = 'Russian translation by Loufeer (RU)',
			twitter = 'Follow me on Twitter #NaifuKishi'
		}
	}
	
end