local nkRebuffInfo, nkRebuff = ...

nkRebuff.processing = {}

function nkRebuff.processing.processBuffs (missing, nearRunoutList)

	local counter = 1
	local iconIndex = 1
	
	for k, v in pairs(nkRebuff.UIelements.buffBar.icons) do v:SetVisible(false) end								
	
	for name, buff in pairs (missing) do
		if counter <= (nkRBSetup.bars[nkRebuff.const.barBuffsID].noOfIcons) then
			iconIndex = nkRebuff.processing.calcIndex (nkRebuff.const.barBuffsID, name, counter)
			
			if nkRebuff.UIelements.buffBar.icons[iconIndex] ~= nil then
				if nearRunoutList[name] ~= nil then	
					nkRebuff.UIelements.buffBar.icons[iconIndex]:Update(nkRebuff.const.barBuffsID, { type = 'buff', label = name, texture = buff.icon, remaining = nearRunoutList[name], ability = buff.ability, stack = buff.stack })
				else
					nkRebuff.UIelements.buffBar.icons[iconIndex]:Update(nkRebuff.const.barBuffsID, { type = 'buff', label = name, texture = buff.icon, ability = buff.ability, stack = buff.stack })
				end
			end
			
			counter = counter + 1
			
		end
	end
	
end

function nkRebuff.processing.processTarget ()

	local debuffs = {}
	debuffs.active = {}
	debuffs.nearRunoutList = {}
	debuffs.missing = {}
	
	local buffTarget = {}
	buffTarget.active = {}
	buffTarget.nearRunoutList = {}
	buffTarget.missing = {}
	
	local debuffList = Inspect.Buff.List('player.target')
					
	if debuffList then
		local debuffDetails = Inspect.Buff.Detail("player.target", debuffList)
		for k, debuff in pairs(debuffDetails) do			
			local caster = debuff.caster
			local casterDetails = Inspect.Unit.Detail(caster)
			if casterDetails ~= nil and casterDetails.name == Inspect.Unit.Detail ('player').name then

				if nkRebuff.events.trackAbility ('debuff', debuff.name, debuff.stack) == true then
					debuffs.active[debuff.name] = debuff			
					
					if nkRebuff.events.checkRemaining (debuff.remaining, nkRBSetup.sets[nkRBSetup.basic.activeSet].debuff[debuff.name].customRemaining, nkRBSetup.sets[nkRBSetup.basic.activeSet].debuff[debuff.name].runoutDuration, nkRBSetup.bars[nkRebuff.const.barDebuffsID].runoutDuration) == true then
						debuffs.nearRunoutList[debuff.name] = debuff.remaining 
					end

				elseif nkRebuff.events.trackAbility ('buffTarget', debuff.name, debuff.stack) == true then
					buffTarget.active[debuff.name] = debuff			

					if nkRBSetup.sets[nkRBSetup.basic.activeSet].buffTarget[debuff.name].nms == true or nkRebuff.events.checkRemaining (debuff.remaining, nkRBSetup.sets[nkRBSetup.basic.activeSet].buffTarget[debuff.name].customRemaining, nkRBSetup.sets[nkRBSetup.basic.activeSet].buffTarget[debuff.name].runoutDuration, nkRBSetup.bars[nkRebuff.const.barbuffTargetID].runoutDuration) == true then
						buffTarget.nearRunoutList[debuff.name] = debuff.remaining 
					end
				end
			end
		end
	else
		for k, debuff in pairs(nkRBSetup.data.debuff) do debuffs.active[k] = debuff end
		for k, debuff in pairs(nkRBSetup.data.buff) do buffTarget.active[k] = debuff end
	end
	
	nkRebuff.processing.processTargetShowIcons (nkRBSetup.sets[nkRBSetup.basic.activeSet].debuff, nkRBSetup.data.debuff, nkRebuff.const.barDebuffsID, nkRebuff.UIelements.debuffBar, 'debuff', debuffs)
	nkRebuff.processing.processTargetShowIcons (nkRBSetup.sets[nkRBSetup.basic.activeSet].buffTarget, nkRBSetup.data.buff, nkRebuff.const.barbuffTargetID, nkRebuff.UIelements.buffTargetBar, 'buffTarget', buffTarget)

end

function nkRebuff.processing.processTargetShowIcons (set, data, barID, bar, barType, items)

	for name, details in pairs (set) do
		if details.active == true and (items.active[name] == nil or items.nearRunoutList[name] ~= nil) then
			if details.nms ~= true or (details.nms == true and items.nearRunoutList[name] ~= nil) then
				if items.nearRunoutList[name] ~= nil and nkRBSetup.basic.remainingWarning == true and details.dnw ~= true then
					nkRebuff.privateVars.warnItems.items[name] = data[name] 
					nkRebuff.privateVars.warnItems.items[name].stack = data[name].stack
					nkRebuff.privateVars.warnItems.items[name].remaining = items.nearRunoutList[name]
					nkRebuff.privateVars.warnItems.warningCount = nkRebuff.privateVars.warnItems.warningCount + 1	
				else
					items.missing[name] = data[name]
				end
			end
		end
	end
		
	local counter = 1
	local iconIndex = 1
	
	for name, buff in pairs (items.missing) do
		if counter <= (nkRBSetup.bars[barID].noOfIcons) then						
			iconIndex = nkRebuff.processing.calcIndex (barID, name, counter)
			
			if bar.icons[iconIndex] ~= nil then
				if items.nearRunoutList[name] ~= nil then	
					bar.icons[iconIndex]:Update(barID, { type = barType, label = name, texture = buff.icon, remaining = items.nearRunoutList[name], ability = buff.ability, stack = buff.stack })
				else
					bar.icons[iconIndex]:Update(barID, { type = barType, label = name, texture = buff.icon, ability = buff.ability, stack = buff.stack })
				end
			end
			
			counter = counter + 1
			
		end
	end	

end

function nkRebuff.processing.processDebuffsPlayer (debuffs)

	local counter = 1
	local iconIndex = 1

	for k, v in pairs(nkRebuff.UIelements.debuffPlayerBar.icons) do v:SetVisible(false) end

	if nkRBSetup.basic.debuffWarning == true then
		for name, buff in pairs (debuffs) do					
			if counter <= (nkRBSetup.bars[nkRebuff.const.barDebuffsPlayerID].noOfIcons) then							
				--iconIndex = nkRebuff.processing.calcIndex (counter, nkRBSetup.bars[nkRebuff.const.barDebuffsPlayerID].noOfIcons, nkRBSetup.bars[nkRebuff.const.barDebuffsPlayerID].align)
				iconIndex = nkRebuff.processing.calcIndex (nkRebuff.const.barDebuffsPlayerID, name, counter)
				
				if nkRebuff.UIelements.debuffPlayerBar.icons[iconIndex] ~= nil then
					nkRebuff.UIelements.debuffPlayerBar.icons[iconIndex]:Update(nkRebuff.const.barDebuffsPlayerID, { type = 'debuff3rd', label = name, texture = buff.icon, remaining = buff.remaining, desc = buff.description, stack = buff.stack })
				end
				
				counter = counter + 1
				
			end
		end
	end
	
end

function nkRebuff.processing.processCooldowns ()

	for k, v in pairs(nkRebuff.UIelements.cooldownBar.icons) do v:SetVisible(false) end

	nkRebuff.processing.CheckForCooldowns()
	
	local counter = 1
	local iconIndex = 1
	
	for ability, abilityInfo in pairs (nkRebuff.activeCDList) do
		if counter <= (nkRBSetup.bars[nkRebuff.const.barCooldownsID].noOfIcons) then						
			iconIndex = nkRebuff.processing.calcIndex (nkRebuff.const.barCooldownsID, abilityInfo.name, counter)
						
			if nkRebuff.UIelements.cooldownBar.icons[iconIndex] ~= nil then
				local remaining = abilityInfo.currentCooldownRemaining

				if remaining ~= nil then
					if remaining <= nkRBSetup.basic.gcd then
						nkRebuff.UIelements.cooldownBar.icons[iconIndex]:Update(nkRebuff.const.barCooldownsID, { type = 'CD', label = abilityInfo.name, texture = abilityInfo.icon, ability = ability })
					else
						nkRebuff.UIelements.cooldownBar.icons[iconIndex]:Update(nkRebuff.const.barCooldownsID, { type = 'CD', label = abilityInfo.name, texture = abilityInfo.icon, remaining = remaining, ability = ability })
					end
				else
					nkRebuff.UIelements.cooldownBar.icons[iconIndex]:Update(nkRebuff.const.barCooldownsID, { type = 'CD', label = abilityInfo.name, texture = abilityInfo.icon, ability = ability })
				end
			end
			
			counter = counter + 1
			
		end
	end

end

function nkRebuff.processing.processAbilities(activeAbilities)

	local counter = 1
	local iconIndex = 1
	
	for k, v in pairs(nkRebuff.UIelements.activeBar.icons) do v:SetVisible(false) end								
	
	for name, buff in pairs (activeAbilities) do
	
		if counter <= (nkRBSetup.bars[5].noOfIcons) then
			--iconIndex = nkRebuff.processing.calcIndex (counter, nkRBSetup.bars[nkRebuff.const.barAbilitiesID].noOfIcons, nkRBSetup.bars[nkRebuff.const.barAbilitiesID].align)
			iconIndex = nkRebuff.processing.calcIndex (nkRebuff.const.barAbilitiesID, name, counter)
			if nkRebuff.UIelements.activeBar.icons[iconIndex] ~= nil then
				nkRebuff.UIelements.activeBar.icons[iconIndex]:Update(nkRebuff.const.barAbilitiesID, { type = 'ability', label = name, texture = buff.icon, remaining = buff.remaining, ability = buff.ability })
			end
			
			counter = counter + 1
		end
	end

end

function nkRebuff.processing.processWarnings()

	local counter = 1
	local iconIndex = 1
	
	for k, v in pairs(nkRebuff.UIelements.warningBar.icons) do v:SetVisible(false) end								
	
	for name, item in pairs (nkRebuff.privateVars.warnItems.items) do
		if counter <= (nkRBSetup.bars[nkRebuff.const.barWarningsID].noOfIcons) then
			--iconIndex = nkRebuff.processing.calcIndex (counter, nkRBSetup.bars[nkRebuff.const.barWarningsID].noOfIcons, nkRBSetup.bars[nkRebuff.const.barWarningsID].align)
			iconIndex = nkRebuff.processing.calcIndex (nkRebuff.const.barWarningsID, name, counter)
			
			if nkRebuff.UIelements.warningBar.icons[iconIndex] ~= nil then
				nkRebuff.UIelements.warningBar.icons[iconIndex]:Update(nkRebuff.const.barWarningsID, { type = 'ability', label = name, texture = item.icon, remaining = item.remaining, ability = item.ability })
			end
			
			counter = counter + 1
		end
	end

end

-- helper functions

function nkRebuff.processing.CheckForCooldowns ()

	nkRebuff.activeCDList = {}

	for k, v in pairs (nkRBSetup.data.CD) do
		
		if nkRebuff.events.trackAbility ('CD', k) then
		
			local details = Inspect.Ability.New.Detail(v.ability)
			if details ~= nil then
				if nkRebuff.activeCDList[v.ability] == nil then
					if details.currentCooldownRemaining == nil or nkTools.math.round (details.currentCooldownDuration, 1) == nkRBSetup.basic.gcd then
						nkRebuff.activeCDList[v.ability] = details
					else
						if nkRebuff.events.checkRemaining (details.currentCooldownRemaining, nkRBSetup.sets[nkRBSetup.basic.activeSet].CD[k].customRemaining, nkRBSetup.sets[nkRBSetup.basic.activeSet].CD[k].runoutDuration, nkRBSetup.bars[nkRebuff.const.barCooldownsID].runoutDuration) then
							if nkRBSetup.basic.remainingWarning == true then
								nkRebuff.privateVars.warnItems.items[details.name] = details
								nkRebuff.privateVars.warnItems.items[details.name].remaining = details.currentCooldownRemaining
								nkRebuff.privateVars.warnItems.items[details.name].ability = v.ability
								nkRebuff.privateVars.warnItems.warningCount = nkRebuff.privateVars.warnItems.warningCount + 1	
							else
								nkRebuff.activeCDList[v.ability] = details
							end
						end
					end
				end
			end
		end
		
	end

end

function nkRebuff.processing.calcIndex (barID, name, counter)

	local noOfIcons =  nkRBSetup.bars[barID].noOfIcons
	local align = nkRBSetup.bars[barID].align
	local iconIndex = 0
	
	if align == 'fixed' then
		if nkRebuff.privateVars.fixedIconPos[barID] == nil then nkRebuff.privateVars.fixedIconPos[barID] = {} end
		
		if nkRebuff.privateVars.fixedIconPos[barID][name] == nil then
			iconIndex = 1
			for k, v in pairs (nkRebuff.privateVars.fixedIconPos[barID]) do iconIndex = iconIndex + 1 end
			
			nkRebuff.privateVars.fixedIconPos[barID][name] = iconIndex
		else		
			iconIndex = nkRebuff.privateVars.fixedIconPos[barID][name]
		end		
	else			
		local iconCenter = math.floor(noOfIcons / 2)
		if math.floor(noOfIcons / 2) == noOfIcons / 2 then iconCenter = iconCenter -1  end
		
		if align == 'vertical' or align == 'left' then  
			iconIndex = counter
		elseif align == 'right' then
			iconIndex = noOfIcons - (counter-1)
		else
			if (counter / 2) == math.floor(counter/2) then
				iconIndex = math.floor(iconCenter + math.floor(counter / 2) + 1)
			else
				iconIndex = math.floor(iconCenter- math.floor(counter / 2) + 1)
			end
		end
	end
	
	return iconIndex
end